searchNodes=[{"doc":"This module provides Amqpx-related types.","ref":"Amqpx.html","title":"Amqpx","type":"module"},{"doc":"","ref":"Amqpx.html#t:argument_type/0","title":"Amqpx.argument_type/0","type":"type"},{"doc":"","ref":"Amqpx.html#t:arguments/0","title":"Amqpx.arguments/0","type":"type"},{"doc":"Functions to publish, consume and acknowledge messages.","ref":"Amqpx.Basic.html","title":"Amqpx.Basic","type":"module"},{"doc":"Acknowledges one or more messages. Options :multiple - If set, all messages up to the one specified by delivery_tag are acknowledged. Defaults to false .","ref":"Amqpx.Basic.html#ack/3","title":"Amqpx.Basic.ack/3","type":"function"},{"doc":"Stops the given consumer from consuming. This method cancels a consumer. This does not affect already delivered messages, but it does mean the server will not send any more messages for that consumer. The client may receive an arbitrary number of messages in between sending the cancel method and receiving the reply. consumer_tag identifies the &quot;subscription&quot; to cancel, that is, the subscription of a consumer to a specific queue. The consumer tag is returned by consume/4 . Options :no_wait - If set, the cancel operation is asynchronous. Defaults to false .","ref":"Amqpx.Basic.html#cancel/3","title":"Amqpx.Basic.cancel/3","type":"function"},{"doc":"Removes the return handler, if it exists. Does nothing if there is no such handler.","ref":"Amqpx.Basic.html#cancel_return/1","title":"Amqpx.Basic.cancel_return/1","type":"function"},{"doc":"Registers a queue consumer process. The pid of the process can be set using the consumer_pid argument and defaults to the calling process. The consumer process will receive the following data structures: {:basic_deliver, payload, meta} - This is sent for each message consumed, where payload contains the message content and meta contains all the metadata set when sending with Basic.publish or additional info set by the broker; {:basic_consume_ok, %{consumer_tag: consumer_tag}} - Sent when the consumer process is registered with Basic.consume. The caller receives the same information as the return of Basic.consume; {:basic_cancel, %{consumer_tag: consumer_tag, no_wait: no_wait}} - Sent by the broker when the consumer is unexpectedly cancelled (such as after a queue deletion) {:basic_cancel_ok, %{consumer_tag: consumer_tag}} - Sent to the consumer process after a call to Basic.cancel Options :consumer_tag - Specifies the consumer tag for this consumer (as a string). This tag is local to the given channel chan , so different channels can have consumers that use the same consumer tag. If the given consumer tag is &quot;&quot; , then the server autogenerates the tag. Defaults to &quot;&quot; . :no_local - If set, the server won't send messages to the connection that published them. Defaults to false . :no_ack - If set, the server will not expect message acks from the consumer and will consider every message that it believes was delivered to the consumer as acknowledged. Defaults to false , meaning that messages need to be acked explicitly through ack/3 . :exclusive - If set, requests exclusive consumer access, meaning that only this consumer can consume from the given queue . Note that the client cannot have exclusive access to a queue that already has consumers. :no_wait - If set, the consume operation is asynchronous. Defaults to false . :arguments - A list of arguments to pass when consuming (of type Amqpx.arguments/0 ). See the README for more information. Defaults to [] .","ref":"Amqpx.Basic.html#consume/4","title":"Amqpx.Basic.consume/4","type":"function"},{"doc":"Polls a queue for an existing message. Returns the tuple {:empty, meta} if the queue is empty or the tuple {:ok, payload, meta} if at least one message exists in the queue. The returned meta map includes the entry :message_count with the current number of messages in the queue. Receiving messages by polling a queue is not as as efficient as subscribing a consumer to a queue, so consideration should be taken when receiving large volumes of messages. Options :no_ack - If set, the broker is told that the received will not send an acknoledgement of the message. Once the broker believes it has delivered the message, then it's free to assume that the consuming application has taken responsibility for it. In general, a lot of applications will not want these semantics, rather, they will want to explicitly acknowledge the receipt of a message (through ack/3 ). Defaults to false (meaning explicit acks).","ref":"Amqpx.Basic.html#get/3","title":"Amqpx.Basic.get/3","type":"function"},{"doc":"Negative acknowledges of one or more messages. This is a RabbitMQ specific extension to Amqpx 0.9.1. It is equivalent to reject/3 , but allows rejecting multiple messages using the multiple option. Options :multiple - If set, all messages up to the one specified by delivery_tag are considered as not acknowledged by the server. Defaults to false . :requeue - If set, the message will be returned to the queue and redelivered to the next available consumer. Defaults to true .","ref":"Amqpx.Basic.html#nack/3","title":"Amqpx.Basic.nack/3","type":"function"},{"doc":"Publishes a message to an Exchange. This method publishes a message to a specific exchange. The message will be routed to queues as defined by the exchange configuration and distributed to any subscribers. The parameter exchange specifies the name of the exchange to publish to. If set to empty string, it publishes to the default exchange. The routing_key parameter specifies the routing key for the message. The payload parameter specifies the message content as a binary. In addition to the previous parameters, the following options can be used: Options :mandatory - If set, returns an error if the broker can't route the message to a queue (default false ); :immediate - If set, returns an error if the broker can't deliver the message to a consumer immediately (default false ); :content_type - MIME Content type; :content_encoding - MIME Content encoding; :headers - Message headers of type Amqpx.arguments/0 . Can be used with headers Exchanges; :persistent - If set, uses persistent delivery mode. Messages marked as persistent that are delivered to durable queues will be logged to disk; :correlation_id - application correlation identifier; :priority - message priority, ranging from 0 to 9; :reply_to - name of the reply queue; :expiration - how long the message is valid (in milliseconds); :message_id - message identifier; :timestamp - timestamp associated with this message (epoch time); :type - message type as a string; :user_id - creating user ID. RabbitMQ will validate this against the active connection user; :app_id - publishing application ID. Examples iex&gt; Amqpx.Basic . publish chan , &quot;my_exchange&quot; , &quot;my_routing_key&quot; , &quot;Hello World!&quot; , persistent : true :ok","ref":"Amqpx.Basic.html#publish/5","title":"Amqpx.Basic.publish/5","type":"function"},{"doc":"Sets the message prefetch count or prefetech size (in bytes). Options :prefetch_size - the prefetch size (in bytes). Defaults to 0 . :prefetch_count - the prefetch count. Defaults to 0 . :global - If set, this applies to the entire Connection, otherwise it applies only to the given Channel. Defaults to false .","ref":"Amqpx.Basic.html#qos/2","title":"Amqpx.Basic.qos/2","type":"function"},{"doc":"Asks the server to redeliver all unacknowledged messages on a specified channel. Options :requeue - If set, the server will attempt to requeue the message, potentially delivering it to another subscriber. Otherwise it will be redelivered to the original recipient. Defaults to false .","ref":"Amqpx.Basic.html#recover/2","title":"Amqpx.Basic.recover/2","type":"function"},{"doc":"Rejects (and, optionally, requeues) a message. Options :requeue - If set, the message is requeued by the server, otherwise it's discarded. Defaults to true .","ref":"Amqpx.Basic.html#reject/3","title":"Amqpx.Basic.reject/3","type":"function"},{"doc":"Registers a handler to deal with returned messages. The registered process will receive {:basic_return, payload, meta} tuples.","ref":"Amqpx.Basic.html#return/2","title":"Amqpx.Basic.return/2","type":"function"},{"doc":"","ref":"Amqpx.Basic.html#t:consumer_tag/0","title":"Amqpx.Basic.consumer_tag/0","type":"type"},{"doc":"","ref":"Amqpx.Basic.html#t:delivery_tag/0","title":"Amqpx.Basic.delivery_tag/0","type":"type"},{"doc":"","ref":"Amqpx.Basic.html#t:error/0","title":"Amqpx.Basic.error/0","type":"type"},{"doc":"","ref":"Amqpx.Basic.html#t:exchange/0","title":"Amqpx.Basic.exchange/0","type":"type"},{"doc":"","ref":"Amqpx.Basic.html#t:payload/0","title":"Amqpx.Basic.payload/0","type":"type"},{"doc":"","ref":"Amqpx.Basic.html#t:queue/0","title":"Amqpx.Basic.queue/0","type":"type"},{"doc":"","ref":"Amqpx.Basic.html#t:routing_key/0","title":"Amqpx.Basic.routing_key/0","type":"type"},{"doc":"Functions to operate on Channels.","ref":"Amqpx.Channel.html","title":"Amqpx.Channel","type":"module"},{"doc":"Closes an open Channel.","ref":"Amqpx.Channel.html#close/1","title":"Amqpx.Channel.close/1","type":"function"},{"doc":"Opens a new Channel in a previously opened Connection.","ref":"Amqpx.Channel.html#open/1","title":"Amqpx.Channel.open/1","type":"function"},{"doc":"","ref":"Amqpx.Channel.html#open/2","title":"Amqpx.Channel.open/2","type":"function"},{"doc":"","ref":"Amqpx.Channel.html#t:t/0","title":"Amqpx.Channel.t/0","type":"type"},{"doc":"Functions that work with publisher confirms (RabbitMQ extension to Amqpx 0.9.1).","ref":"Amqpx.Confirm.html","title":"Amqpx.Confirm","type":"module"},{"doc":"On channel with confirm activated, return the next message sequence number. To use in combination with register_confirm_handler/2","ref":"Amqpx.Confirm.html#next_publish_seqno/1","title":"Amqpx.Confirm.next_publish_seqno/1","type":"function"},{"doc":"This registers a handler for confirms on channel. The handler will receive either: {:basic_ack, seqno, multiple} {:basic_nack, seqno, multiple} The seqno (delivery_tag) is an integer, the sequence number of the message. multiple is a boolean, when true means multiple messages confirm, upto seqno . see https://www.rabbitmq.com/confirms.html","ref":"Amqpx.Confirm.html#register_confirm_handler/2","title":"Amqpx.Confirm.register_confirm_handler/2","type":"function"},{"doc":"This registers a handler to deal with channel flow notifications.","ref":"Amqpx.Confirm.html#register_flow_handler/2","title":"Amqpx.Confirm.register_flow_handler/2","type":"function"},{"doc":"This registers a handler to deal with returned messages.","ref":"Amqpx.Confirm.html#register_return_handler/2","title":"Amqpx.Confirm.register_return_handler/2","type":"function"},{"doc":"Activates publishing confirmations on the channel.","ref":"Amqpx.Confirm.html#select/1","title":"Amqpx.Confirm.select/1","type":"function"},{"doc":"This removes the confirm handler, if it exists. Does nothing if there is no such handler.","ref":"Amqpx.Confirm.html#unregister_confirm_handler/1","title":"Amqpx.Confirm.unregister_confirm_handler/1","type":"function"},{"doc":"This removes the flow handler, if it exists. Does nothing if there is no such handler.","ref":"Amqpx.Confirm.html#unregister_flow_handler/1","title":"Amqpx.Confirm.unregister_flow_handler/1","type":"function"},{"doc":"This removes the return handler, if it exists. Does nothing if there is no such handler.","ref":"Amqpx.Confirm.html#unregister_return_handler/1","title":"Amqpx.Confirm.unregister_return_handler/1","type":"function"},{"doc":"Wait until all messages published since the last call have been either ack'd or nack'd by the broker.","ref":"Amqpx.Confirm.html#wait_for_confirms/1","title":"Amqpx.Confirm.wait_for_confirms/1","type":"function"},{"doc":"Wait until all messages published since the last call have been either ack'd or nack'd by the broker, or until timeout elapses.","ref":"Amqpx.Confirm.html#wait_for_confirms/2","title":"Amqpx.Confirm.wait_for_confirms/2","type":"function"},{"doc":"Wait until all messages published since the last call have been either ack'd or nack'd by the broker, or until timeout elapses. If any of the messages were nack'd, the calling process dies.","ref":"Amqpx.Confirm.html#wait_for_confirms_or_die/1","title":"Amqpx.Confirm.wait_for_confirms_or_die/1","type":"function"},{"doc":"","ref":"Amqpx.Confirm.html#wait_for_confirms_or_die/2","title":"Amqpx.Confirm.wait_for_confirms_or_die/2","type":"function"},{"doc":"Functions to operate on Connections.","ref":"Amqpx.Connection.html","title":"Amqpx.Connection","type":"module"},{"doc":"Closes an open Connection.","ref":"Amqpx.Connection.html#close/1","title":"Amqpx.Connection.close/1","type":"function"},{"doc":"Opens a new connection without a name. Behaves exactly like open(options_or_uri, :undefined) . See open/2 .","ref":"Amqpx.Connection.html#open/1","title":"Amqpx.Connection.open/1","type":"function"},{"doc":"Opens an new Connection to an Amqpx broker. The connections created by this module are supervised under amqp_client's supervision tree. Please note that connections do not get restarted automatically by the supervision tree in case of a failure. If you need robust connections and channels, use monitors on the returned connection PID. This function can be called in three ways: with a list of options and a name with an Amqpx URI and a name with an Amqpx URI and a list of options (in this case, the options are merged with the Amqpx URI, taking precedence on same keys) Options :username - The name of a user registered with the broker (defaults to &quot;guest&quot; ); :password - The password of user (defaults to &quot;guest&quot; ); :virtual_host - The name of a virtual host in the broker (defaults to &quot;/&quot; ); :host - The hostname of the broker (defaults to &quot;localhost&quot; ); :port - The port the broker is listening on (defaults to 5672 ); :channel_max - The channel_max handshake parameter (defaults to 0 ); :frame_max - The frame_max handshake parameter (defaults to 0 ); :heartbeat - The hearbeat interval in seconds (defaults to 10 ); :connection_timeout - The connection timeout in milliseconds (defaults to 50000 ); :ssl_options - Enable SSL by setting the location to cert files (defaults to :none ); :client_properties - A list of extra client properties to be sent to the server, defaults to [] ; :socket_options - Extra socket options. These are appended to the default options. See http://www.erlang.org/doc/man/inet.html#setopts-2 and http://www.erlang.org/doc/man/gen_tcp.html#connect-4 for descriptions of the available options. Enabling SSL To enable SSL, supply the following in the ssl_options field: cacertfile - Specifies the certificates of the root Certificate Authorities that we wish to implicitly trust; certfile - The client's own certificate in PEM format; keyfile - The client's private key in PEM format; Example Amqpx.Connection . open port : 5671 , ssl_options : [ cacertfile : &#39;/path/to/testca/cacert.pem&#39; , certfile : &#39;/path/to/client/cert.pem&#39; , keyfile : &#39;/path/to/client/key.pem&#39; , # only necessary with intermediate CAs # depth: 2, verify : :verify_peer , fail_if_no_peer_cert : true ] Connection name RabbitMQ supports user-specified connection names since version 3.6.2. Connection names are human-readable strings that will be displayed in the management UI. Connection names do not have to be unique and cannot be used as connection identifiers. If the name is :undefined , the connection is not registered with any name. Examples iex&gt; options = [ host : &quot;localhost&quot; , port : 5672 , virtual_host : &quot;/&quot; , username : &quot;guest&quot; , password : &quot;guest&quot; ] iex&gt; Amqpx.Connection . open ( options , :undefined ) { :ok , % Amqpx.Connection { } } iex&gt; Amqpx.Connection . open ( &quot;amqp://guest:guest@localhost&quot; , port : 5673 ) { :ok , % Amqpx.Connection { } } iex&gt; Amqpx.Connection . open ( &quot;amqp://guest:guest@localhost&quot; , &quot;a-connection-with-a-name&quot; ) { :ok , % Amqpx.Connection { } }","ref":"Amqpx.Connection.html#open/2","title":"Amqpx.Connection.open/2","type":"function"},{"doc":"Opens a new connection with a name, merging the given Amqpx URI and options. This function opens a new connection by merging the given Amqpx URI uri and the given options and assigns it the name name . The options in options take precedence over the values in uri . See open/2 for options. Examples iex&gt; Amqpx.Connection . open ( &quot;amqp://guest:guest@localhost&quot; , &quot;a-connection-name&quot; , port : 5673 ) { :ok , % Amqpx.Connection { } }","ref":"Amqpx.Connection.html#open/3","title":"Amqpx.Connection.open/3","type":"function"},{"doc":"","ref":"Amqpx.Connection.html#t:t/0","title":"Amqpx.Connection.t/0","type":"type"},{"doc":"Functions to operate on Exchanges.","ref":"Amqpx.Exchange.html","title":"Amqpx.Exchange","type":"module"},{"doc":"Binds an Exchange to another Exchange using the exchange.bind Amqpx method (a RabbitMQ-specific extension). Options :routing_key - the routing key to use for the binding. Defaults to &quot;&quot; . :no_wait - If set, the bind operation is asynchronous. Defaults to false . :arguments - A list of arguments to pass when binding (of type Amqpx.arguments/0 ). See the README for more information. Defaults to [] .","ref":"Amqpx.Exchange.html#bind/4","title":"Amqpx.Exchange.bind/4","type":"function"},{"doc":"Declares an Exchange. The default Exchange type is direct . Amqpx 0-9-1 brokers provide four pre-declared exchanges: :direct exchange: (empty string) or amq.direct :fanout exchange: amq.fanout :topic exchange: amq.topic :headers exchange: amq.match (and amq.headers in RabbitMQ) Besides the exchange name and type, the following options can be used: Options :durable - If set, keeps the Exchange between restarts of the broker; :auto_delete - If set, deletes the Exchange once all queues unbind from it; :passive - If set, returns an error if the Exchange does not already exist; :internal - If set, the exchange may not be used directly by publishers, but only when bound to other exchanges. Internal exchanges are used to construct wiring that is not visible to applications. :no_wait - If set, the declare operation is asynchronous. Defaults to false . :arguments - A list of arguments to pass when declaring (of type Amqpx.arguments/0 ). See the README for more information. Defaults to [] .","ref":"Amqpx.Exchange.html#declare/4","title":"Amqpx.Exchange.declare/4","type":"function"},{"doc":"Deletes an Exchange by name. When an Exchange is deleted all bindings to it are also deleted. Options :if_unused - If set, the server will only delete the exchange if it has no queue bindings. :no_wait - If set, the delete operation is asynchronous. Defaults to false .","ref":"Amqpx.Exchange.html#delete/3","title":"Amqpx.Exchange.delete/3","type":"function"},{"doc":"Convenience function to declare an Exchange of type direct . Options This function takes the same options as declare/4 .","ref":"Amqpx.Exchange.html#direct/3","title":"Amqpx.Exchange.direct/3","type":"function"},{"doc":"Convenience function to declare an Exchange of type fanout . Options This function takes the same options as declare/4 .","ref":"Amqpx.Exchange.html#fanout/3","title":"Amqpx.Exchange.fanout/3","type":"function"},{"doc":"Convenience function to declare an Exchange of type topic . Options This function takes the same options as declare/4 .","ref":"Amqpx.Exchange.html#topic/3","title":"Amqpx.Exchange.topic/3","type":"function"},{"doc":"Unbinds an Exchange from another Exchange or a Queue using the exchange.unbind Amqpx method (a RabbitMQ-specific extension). Options :routing_key - the routing key to use for the binding. Defaults to &quot;&quot; . :no_wait - If set, the declare operation is asynchronous. Defaults to false . :arguments - A list of arguments to pass when declaring (of type Amqpx.arguments/0 ). See the README for more information. Defaults to [] .","ref":"Amqpx.Exchange.html#unbind/4","title":"Amqpx.Exchange.unbind/4","type":"function"},{"doc":"Handle connection for all consumers and producer","ref":"Amqpx.Gen.ConnectionManager.html","title":"Amqpx.Gen.ConnectionManager","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Amqpx.Gen.ConnectionManager.html#child_spec/1","title":"Amqpx.Gen.ConnectionManager.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Amqpx.Gen.ConnectionManager.html#init/1","title":"Amqpx.Gen.ConnectionManager.init/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.ConnectionManager.html#start_link/1","title":"Amqpx.Gen.ConnectionManager.start_link/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.ConnectionManager.html#t:state/0","title":"Amqpx.Gen.ConnectionManager.state/0","type":"type"},{"doc":"Generic implementation of amqp consumer","ref":"Amqpx.Gen.Consumer.html","title":"Amqpx.Gen.Consumer","type":"behaviour"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Amqpx.Gen.Consumer.html#child_spec/1","title":"Amqpx.Gen.Consumer.child_spec/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.Consumer.html#c:handle_message/3","title":"Amqpx.Gen.Consumer.handle_message/3","type":"callback"},{"doc":"","ref":"Amqpx.Gen.Consumer.html#c:handle_message_rejection/2","title":"Amqpx.Gen.Consumer.handle_message_rejection/2","type":"callback"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Amqpx.Gen.Consumer.html#init/1","title":"Amqpx.Gen.Consumer.init/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.Consumer.html#c:setup/1","title":"Amqpx.Gen.Consumer.setup/1","type":"callback"},{"doc":"","ref":"Amqpx.Gen.Consumer.html#start_link/1","title":"Amqpx.Gen.Consumer.start_link/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.Consumer.html#t:state/0","title":"Amqpx.Gen.Consumer.state/0","type":"type"},{"doc":"Generic implementation of amqp producer","ref":"Amqpx.Gen.Producer.html","title":"Amqpx.Gen.Producer","type":"module"},{"doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"Amqpx.Gen.Producer.html#child_spec/1","title":"Amqpx.Gen.Producer.child_spec/1","type":"function"},{"doc":"Callback implementation for GenServer.init/1 .","ref":"Amqpx.Gen.Producer.html#init/1","title":"Amqpx.Gen.Producer.init/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.Producer.html#publish/4","title":"Amqpx.Gen.Producer.publish/4","type":"function"},{"doc":"","ref":"Amqpx.Gen.Producer.html#publish_by/5","title":"Amqpx.Gen.Producer.publish_by/5","type":"function"},{"doc":"","ref":"Amqpx.Gen.Producer.html#start_link/1","title":"Amqpx.Gen.Producer.start_link/1","type":"function"},{"doc":"","ref":"Amqpx.Gen.Producer.html#t:state/0","title":"Amqpx.Gen.Producer.state/0","type":"type"},{"doc":"Helper functions","ref":"Amqpx.Helper.html","title":"Amqpx.Helper","type":"module"},{"doc":"","ref":"Amqpx.Helper.html#consumers_supervisor_configuration/1","title":"Amqpx.Helper.consumers_supervisor_configuration/1","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#declare/2","title":"Amqpx.Helper.declare/2","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#encrypt_password/1","title":"Amqpx.Helper.encrypt_password/1","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#get_password/2","title":"Amqpx.Helper.get_password/2","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#manager_supervisor_configuration/1","title":"Amqpx.Helper.manager_supervisor_configuration/1","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#producer_supervisor_configuration/1","title":"Amqpx.Helper.producer_supervisor_configuration/1","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#setup_dead_lettering/2","title":"Amqpx.Helper.setup_dead_lettering/2","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#setup_exchange/2","title":"Amqpx.Helper.setup_exchange/2","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#setup_exchange/3","title":"Amqpx.Helper.setup_exchange/3","type":"function"},{"doc":"","ref":"Amqpx.Helper.html#setup_queue/2","title":"Amqpx.Helper.setup_queue/2","type":"function"},{"doc":"Functions to operate on Queues.","ref":"Amqpx.Queue.html","title":"Amqpx.Queue","type":"module"},{"doc":"Binds a Queue to an Exchange. Options :routing_key - The routing key used to bind the queue to the exchange. Defaults to &quot;&quot; . :no_wait - If true , the binding is not synchronous. Defaults to false . :arguments - A list of arguments to pass when binding (of type Amqpx.arguments/0 ). See the README for more information. Defaults to [] .","ref":"Amqpx.Queue.html#bind/4","title":"Amqpx.Queue.bind/4","type":"function"},{"doc":"Returns a number of active consumers on the queue.","ref":"Amqpx.Queue.html#consumer_count/2","title":"Amqpx.Queue.consumer_count/2","type":"function"},{"doc":"Declares a queue. The optional queue parameter is used to set the name. If set to an empty string (default), the server will assign a name. Besides the queue name, the following options can be used: Options :durable - If set, keeps the Queue between restarts of the broker. Defaults to false . :auto_delete - If set, deletes the Queue once all subscribers disconnect. Defaults to false . :exclusive - If set, only one subscriber can consume from the Queue. Defaults to false . :passive - If set, raises an error unless the queue already exists. Defaults to false . :no_wait - If set, the declare operation is asynchronous. Defaults to false . :arguments - A list of arguments to pass when declaring (of type Amqpx.arguments/0 ). See the README for more information. Defaults to [] .","ref":"Amqpx.Queue.html#declare/3","title":"Amqpx.Queue.declare/3","type":"function"},{"doc":"Deletes a Queue by name. Options :if_unused - If set, the server will only delete the queue if it has no consumers. If the queue has consumers, it's not deleted and an error is returned. :if_empty - If set, the server will only delete the queue if it has no messages. :no_wait - If set, the delete operation is asynchronous.","ref":"Amqpx.Queue.html#delete/3","title":"Amqpx.Queue.delete/3","type":"function"},{"doc":"Returns true if queue is empty (has no messages ready), false otherwise.","ref":"Amqpx.Queue.html#empty?/2","title":"Amqpx.Queue.empty?/2","type":"function"},{"doc":"Returns the number of messages that are ready for delivery (e.g. not pending acknowledgements) in the queue.","ref":"Amqpx.Queue.html#message_count/2","title":"Amqpx.Queue.message_count/2","type":"function"},{"doc":"Discards all messages in the Queue.","ref":"Amqpx.Queue.html#purge/2","title":"Amqpx.Queue.purge/2","type":"function"},{"doc":"Returns the message count and consumer count for the given queue. Uses declare/3 with the :passive option set.","ref":"Amqpx.Queue.html#status/2","title":"Amqpx.Queue.status/2","type":"function"},{"doc":"Convenience to consume messages from a Queue. The handler function must have arity 2 and will receive as arguments a binary with the message payload and a Map with the message properties. The consumed message will be acknowledged after executing the handler function. If an exception is raised by the handler function, the message is rejected. This convenience function will spawn a process and register it using Amqpx.Basic.consume.","ref":"Amqpx.Queue.html#subscribe/3","title":"Amqpx.Queue.subscribe/3","type":"function"},{"doc":"Unbinds a Queue from an Exchange. Options :routing_key - The routing queue for removing the binding. Defaults to &quot;&quot; . :arguments - A list of arguments to pass when unbinding (of type Amqpx.arguments/0 ). See the README for more information. Defaults to [] .","ref":"Amqpx.Queue.html#unbind/4","title":"Amqpx.Queue.unbind/4","type":"function"},{"doc":"Stops the consumer identified by consumer_tag from consuming. Internally just calls Amqpx.Basic.cancel/2 .","ref":"Amqpx.Queue.html#unsubscribe/2","title":"Amqpx.Queue.unsubscribe/2","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Consumer1.html","title":"Amqpx.Test.Support.Consumer1","type":"module"},{"doc":"Callback implementation for Amqpx.Gen.Consumer.handle_message/3 .","ref":"Amqpx.Test.Support.Consumer1.html#handle_message/3","title":"Amqpx.Test.Support.Consumer1.handle_message/3","type":"function"},{"doc":"Callback implementation for Amqpx.Gen.Consumer.setup/1 .","ref":"Amqpx.Test.Support.Consumer1.html#setup/1","title":"Amqpx.Test.Support.Consumer1.setup/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Consumer2.html","title":"Amqpx.Test.Support.Consumer2","type":"module"},{"doc":"Callback implementation for Amqpx.Gen.Consumer.handle_message/3 .","ref":"Amqpx.Test.Support.Consumer2.html#handle_message/3","title":"Amqpx.Test.Support.Consumer2.handle_message/3","type":"function"},{"doc":"Callback implementation for Amqpx.Gen.Consumer.setup/1 .","ref":"Amqpx.Test.Support.Consumer2.html#setup/1","title":"Amqpx.Test.Support.Consumer2.setup/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Consumer3.html","title":"Amqpx.Test.Support.Consumer3","type":"module"},{"doc":"Callback implementation for Amqpx.Gen.Consumer.handle_message/3 .","ref":"Amqpx.Test.Support.Consumer3.html#handle_message/3","title":"Amqpx.Test.Support.Consumer3.handle_message/3","type":"function"},{"doc":"Callback implementation for Amqpx.Gen.Consumer.setup/1 .","ref":"Amqpx.Test.Support.Consumer3.html#setup/1","title":"Amqpx.Test.Support.Consumer3.setup/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.HandleRejectionConsumer.html","title":"Amqpx.Test.Support.HandleRejectionConsumer","type":"module"},{"doc":"Callback implementation for Amqpx.Gen.Consumer.handle_message/3 .","ref":"Amqpx.Test.Support.HandleRejectionConsumer.html#handle_message/3","title":"Amqpx.Test.Support.HandleRejectionConsumer.handle_message/3","type":"function"},{"doc":"Callback implementation for Amqpx.Gen.Consumer.handle_message_rejection/2 .","ref":"Amqpx.Test.Support.HandleRejectionConsumer.html#handle_message_rejection/2","title":"Amqpx.Test.Support.HandleRejectionConsumer.handle_message_rejection/2","type":"function"},{"doc":"Callback implementation for Amqpx.Gen.Consumer.setup/1 .","ref":"Amqpx.Test.Support.HandleRejectionConsumer.html#setup/1","title":"Amqpx.Test.Support.HandleRejectionConsumer.setup/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Producer1.html","title":"Amqpx.Test.Support.Producer1","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.Producer1.html#send_payload/1","title":"Amqpx.Test.Support.Producer1.send_payload/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Producer2.html","title":"Amqpx.Test.Support.Producer2","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.Producer2.html#send_payload/1","title":"Amqpx.Test.Support.Producer2.send_payload/1","type":"function"},{"doc":"","ref":"Amqpx.Test.Support.Producer3.html","title":"Amqpx.Test.Support.Producer3","type":"module"},{"doc":"","ref":"Amqpx.Test.Support.Producer3.html#send_payload/1","title":"Amqpx.Test.Support.Producer3.send_payload/1","type":"function"},{"doc":"Raised when the connection is closed or blocked.","ref":"Amqpx.BasicError.html","title":"Amqpx.BasicError","type":"exception"}]